Bug 1060817 - Review Request: fllog - Amateur Radio Log Program
Summary: Review Request: fllog - Amateur Radio Log Program
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Volker Fröhlich
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1060818 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-02-03 16:57 UTC by Richard Shaw
Modified: 2015-06-18 18:36 UTC (History)
3 users (show)

Fixed In Version: fllog-1.2.0-1.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-06-15 13:29:30 UTC
Type: ---
tcallawa: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Richard Shaw 2014-02-03 16:57:20 UTC
Spec URL: http://hobbes1069.fedorapeople.org//fllog.spec
SRPM URL: http://hobbes1069.fedorapeople.org//fllog-1.1.7-1.fc19.src.rpm

Description:
Fllog is a transceiver control program for Amateur Radio use.  It does
not use any 3rd party transceiver control libraries.  It is a c++ pro-
gram that encapsulates each transceiver in it's own class.  Where ever
possible the transceiver class(s) use polymorphism to reuse code that
is portable across a series of transceivers.

Comment 1 Richard Shaw 2014-02-03 16:59:39 UTC
*** Bug 1060818 has been marked as a duplicate of this bug. ***

Comment 2 Richard Shaw 2014-02-03 17:01:20 UTC
koji scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6485927

Comment 3 Volker Fröhlich 2014-02-09 11:09:39 UTC
This package seems to bundle xmlrpc++ from https://sourceforge.net/projects/xmlrpcpp/.

Version 1.1.7 is not available to download; please try to package 1.1.8.

You must validate the desktop file. A few compiler warnings should be sorted out upstream and the FSF address should be updated. Also consider to include the AUTHORS file.

I think there's a typo in the description: "it's" should be "its". What does "class(s)" mean? I'm not sure whether the last two lines of the description are very useful as part of the package description.

Comment 4 Volker Fröhlich 2014-02-09 16:50:25 UTC
I'll review the licenses after you un-bundled xmlrpc++.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v2.1 or later) (with incorrect FSF address)", "GPL (v2 or later)",
     "GPL (v3 or later)", "Unknown or generated", "MIT/X11 (BSD like)", "*No
     copyright* GPL (v3 or later)", "LGPL (v2 or later) (with incorrect FSF
     address)", "GPL (v3 or later) (with incorrect FSF address)", "GPL (v2 or
     later) (with incorrect FSF address)". 60 files have unknown license.
     Detailed output of licensecheck in
     /home/makerpm/1060817-fllog/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0:
     http://w1hkj.com/downloads/fllog/fllog-1.1.7.tar.gz
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.

Builds on all primary arches:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6509244

[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: fllog-1.1.7-1.fc21.x86_64.rpm
          fllog-1.1.7-1.fc21.src.rpm
fllog.x86_64: W: spelling-error %description -l en_US polymorphism -> polymorphic, polymorphous
fllog.x86_64: W: no-manual-page-for-binary fllog
fllog.src: W: spelling-error %description -l en_US polymorphism -> polymorphic, polymorphous
fllog.src: W: invalid-url Source0: http://w1hkj.com/downloads/fllog/fllog-1.1.7.tar.gz HTTP Error 404: Not Found
2 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint fllog
fllog.x86_64: W: spelling-error %description -l en_US polymorphism -> polymorphic, polymorphous
fllog.x86_64: W: no-manual-page-for-binary fllog
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
fllog (rpmlib, GLIBC filtered):
    libX11.so.6()(64bit)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libfltk.so.1.3()(64bit)
    libfltk_images.so.1.3()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
fllog:
    application()
    application(fllog.desktop)
    fllog
    fllog(x86-64)



Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b1060817
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 5 Richard Shaw 2014-02-10 00:40:19 UTC
(In reply to Volker Fröhlich from comment #3)
> This package seems to bundle xmlrpc++ from
> https://sourceforge.net/projects/xmlrpcpp/.

Yes, it appears so does the flrig program and it appears to be dead upstream (last update 2003)

He has modified it quite a bit so I'm tempted to say it's a fork, but even if we can agree to that, it's still bundled in almost every one of the programs, even in fldigi which is already in Fedora.

 
> Version 1.1.7 is not available to download; please try to package 1.1.8.

Yes, there was a serious bug found in 1.1.7 but I was going to build 1.1.8 after the review but I'll go ahead and update it now.

 
> You must validate the desktop file. A few compiler warnings should be sorted
> out upstream and the FSF address should be updated. Also consider to include
> the AUTHORS file.

Whoops on the desktop file, fixed. 

> 
> I think there's a typo in the description: "it's" should be "its". What does
> "class(s)" mean? I'm not sure whether the last two lines of the description
> are very useful as part of the package description.

Cut and pasted from upstream, but fixed none-the-less.

Comment 6 Richard Shaw 2014-02-10 02:19:42 UTC
Well I've gone back and forth with the developer and of course from his point of view he doesn't have a problem with bundled libraries since he makes sure it builds for not just Linux, but BSD, MacOS, etc... I tried creating my own library I think successfully using cmake, but I'm not very good with autotools to hack fllog to use the system copy.

Comment 7 Richard Shaw 2014-02-12 04:05:00 UTC
Small update... His xmlrpccpp is no longer the same as xmlrpc++, it is effectively a fork. I did a diff of the two and there are significant differences.

This raises the question, how much code must be the same among several projects (flrig, fldigi, flamp) from the same upstream before it is considered "bundled". 

We went back and forth quite a bit and he agreed to look at allowing the use of a shared library version of xmlrpccpp with the default to remain using the bundled code, HOWEVER, his main rational for not releasing a separate library is that he doesn't want to become the upstream for support of the library for other projects which keeping the code in his source tree does discourage.

Comment 9 Richard Shaw 2014-11-04 15:26:48 UTC
SPEC: https://dl.dropboxusercontent.com/u/34775202/fllog.spec
SRPM: https://dl.dropboxusercontent.com/u/34775202/fllog-1.1.8-1.fc20.src.rpm

New release.

I'm operating under the assumption that the "bundled" xmlrpcpp isn't really bundled as it's forked from upstream, significantly different, only intended to be used to provide communication between upstream's various programs, and he has no intention of providing it as a separate library.

Comment 10 Tom "spot" Callaway 2015-03-17 20:59:35 UTC
This really ought to go through the FPC. I'm inclined to agree with you Richard, but it sets a poor precedent if I just review it with the outstanding issue unresolved.

I'll finish this when they decide whether this is a bundling issue or not.

Comment 11 Richard Shaw 2015-03-19 19:58:15 UTC
https://fedorahosted.org/fpc/ticket/515

Comment 12 Richard Shaw 2015-05-05 18:19:20 UTC
SPEC: https://hobbes1069.fedorapeople.org/fllog.spec
SRPM: https://hobbes1069.fedorapeople.org/fllog-1.2.0-1.fc21.src.rpm

* Tue May  5 2015 Richard Shaw <hobbes1069@gmail.com> - 1.2.0-1
- Update to latest upstream release.
- Build with external xmlrpc library.

Comment 13 Richard Shaw 2015-05-27 19:21:12 UTC
Tom, do you have time to review this package? It should be pretty straightforward now with the new xmlrpc library.

Comment 14 Tom "spot" Callaway 2015-05-27 20:32:07 UTC
== REVIEW ==

Three minor issues:

* You've got a typo in the rm of the bundled xmlrpc library. It should be:

  rm -rf src/xmlrpcpp

* Without the xmlrpcpp bits, there is no LGPL code I can see. Drop that from the License: tag. "GPLv3+ and GPLv2+" is correct.

* BuildRequires: autoconf automake

Don't see those being used. I'm guessing you added these at some point when you were having to regen the configure file. Probably should be removed.

Fix these before doing the Fedora builds, please. :)

Otherwise APPROVED

Good:

- rpmlint checks return:
fllog.src: W: spelling-error %description -l en_US polymorphism -> polymorphic, polymorphous
fllog.x86_64: W: spelling-error %description -l en_US polymorphism -> polymorphic, polymorphous
fllog.x86_64: W: no-manual-page-for-binary fllog
3 packages and 0 specfiles checked; 0 errors, 3 warnings.

All safe to ignore.

- package meets naming guidelines
- package meets packaging guidelines
- license (GPLv3+ and GPLv2+) OK, text in %doc, matches source
- spec file legible, in am. english
- source matches upstream (7cac198e0e9def5853a6b3df1ad1968752a90f0d2d3477e071567fdde4c436d3)
- package compiles on f22 (x86_64)
- no missing BR
- no unnecessary BR (except as noted above)
- no locales
- not relocatable
- owns all directories that it creates
- no duplicate files
- permissions ok
- macro use consistent
- code, not content
- no need for -docs
- nothing in %doc affects runtime
- .desktop okay

Comment 15 Richard Shaw 2015-05-27 21:12:00 UTC
Ok, all 3 fixed! Thanks for the review!

Comment 16 Richard Shaw 2015-05-27 21:14:28 UTC
New Package SCM Request
=======================
Package Name: fllog
Short Description: Amateur Radio Log Program
Upstream URL: http://www.w1hkj.com/
Owners: hobbes1069
Branches: f21 f22 epel7
InitialCC:

Comment 17 Richard Shaw 2015-05-27 21:14:50 UTC
fix cvs flag.

Comment 18 Gwyn Ciesla 2015-05-28 01:37:51 UTC
Git done (by process-git-requests).

Comment 19 Fedora Update System 2015-05-28 03:33:50 UTC
fllog-1.2.0-1.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/fllog-1.2.0-1.el7

Comment 20 Fedora Update System 2015-05-28 03:33:55 UTC
fllog-1.2.0-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/fllog-1.2.0-1.fc21

Comment 21 Fedora Update System 2015-05-28 03:34:02 UTC
fllog-1.2.0-1.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/fllog-1.2.0-1.fc22

Comment 22 Fedora Update System 2015-05-29 21:48:41 UTC
fllog-1.2.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository.

Comment 23 Fedora Update System 2015-06-15 13:29:30 UTC
fllog-1.2.0-1.fc22 has been pushed to the Fedora 22 stable repository.

Comment 24 Fedora Update System 2015-06-15 13:30:15 UTC
fllog-1.2.0-1.fc21 has been pushed to the Fedora 21 stable repository.

Comment 25 Fedora Update System 2015-06-18 18:36:30 UTC
fllog-1.2.0-1.el7 has been pushed to the Fedora EPEL 7 stable repository.


Note You need to log in before you can comment on or make changes to this bug.